题面 | |
---|---|
求余
送分题
答案:
双阶乘
只需要维护最后 位即可,于是一个 for
搞定,边乘边对 取模
答案:
Code
using namespace std; //========================================== signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int mul = 1; for(int i=3;i<=2021;i+=2) mul = mul * i % 100000; cout<<mul<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
格点
两重 for
遍历 值然后加一个判断计数即可
答案:
Code
using namespace std; //========================================== signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int cnt = 0; for(int i=1;i<=2021;i++) for(int j=1;j<=2021;j++) if(i*j<=2021) ++cnt; cout<<cnt<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
整数分解
注意到所求为方案数,求方案数常见两种方法:组合数学或动态规划
本题两种方法均可
组合数学
显然题目即为在 个 的 个空隙中插入 个隔板的方案数
故答案为:
动态规划
- 状态设计: 表示 分成 个正整数之和的方案数
- 初始状态:
- 转移方程:
- 所求结果:
答案:
Code
using namespace std; //========================================== const int maxn = 2025; typedef long long ll; //? 做法一:组合数学 //* 即在 2021 个 1 的 2020 个空隙中插入 4 个隔板 //* 答案:\binom{2020}{4} ll solve1() { ll mul = 1; for(int i=2020;i>2016;i--) mul *= i/(i-2016); return mul; } //? 做法二:DP //* 状态设计:dp[i][j] i 分成 j 个正整数之和的方案数 //* 初始状态:dp[i][1] = 1 //* 转移方程:dp[i][j] = \sum_{k=1}^{i-1} dp[k][j-1] //* 答案:dp[2021][5] ll dp[maxn][maxn]; ll solve2() { int n=2021, m=5; for(int i=1;i<=n;i++) { for(int j=1;j<=min(i,m);j++) { if(j==1) dp[i][j]=1; else { ll sum = 0; for(int k=1;k<i;k++) sum += dp[k][j-1]; dp[i][j]=sum; } } } return dp[n][m]; } signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== cout<<"Method 1:"<<solve1()<<endl; cout<<"Method 2:"<<solve2()<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
城邦
显然最小生成树裸题,下一道
答案:
Code
using namespace std; //========================================== const int maxn = 2025; int fa[maxn]; int find(int x) { return x==fa[x]?x:fa[x]=find(fa[x]); } inline void merge(int x,int y) { fa[find(x)]=find(y); } vector<tuple<int,int,int>> edge; signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int n = 2021; iota(fa+1, fa+1+n, 1); for(int i=1;i<=n;i++) { for(int j=1;j<=n;j++) { string s1=to_string(i), s2=to_string(j); if(s1.length()<s2.length()) s1 = string(s2.length()-s1.length(), '0') + s1; else if(s2.length()<s1.length()) s2 = string(s1.length()-s2.length(), '0') + s2; int sum = 0; for(int i=0;i<s1.length();i++) if(s1[i]!=s2[i]) sum += s1[i]-'0'+s2[i]-'0'; edge.emplace_back(sum,i,j); } } sort(edge.begin(), edge.end()); int ans=0, cnt=0; for(auto [w,u,v] : edge) { if(find(u)!=find(v)) { ans += w; merge(u,v); if(++cnt==n-1) break; } } cout<<ans<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
游戏
又是求方案数,发现这回不能用组合数学了,于是思路转向 DP
- 状态设计: 表示从 开始写的方案数
- 初始状态:
- 转移方程:
- 所求结果:
发现直接递推的话,对于每个数都需要 找约数,时间复杂度是 的,有些慢。于是我们采用刷表法优化,用前向状态去更新后继状态,即用每个数的 DP 值去更新其倍数的 DP 值。时间复杂度
答案:
Code
using namespace std; //========================================== const int maxn = 20210511; typedef long long ll; ll dp[maxn] = {0, 1}; signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int n = 20210509; for(int i=1;i<=n;i++) for(int j=2;j<=n/i;j++) dp[i*j] += dp[i]; cout<<accumulate(dp+1, dp+1+n, 0LL)<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
特殊年份
模拟即可
使用 std::string
可以非常简单地写出程序
Code
using namespace std; //========================================== signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int cnt = 0; for(int i=0;i<5;i++) { string s; cin>>s; if(s[0]==s[2]&&s[1]+1==s[3]) ++cnt; } cout<<cnt<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
小平方
模拟……开个 for
循环即可
Code
using namespace std; //========================================== signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int n; cin>>n; int cnt = 0; for(int i=1;i<n;i++) if(i*i%n<n/2.0) ++cnt; cout<<cnt<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
完全平方数
设 为完全平方数,有:
设 的标准质因数分解式为:
则 的标准质因数分解式为:
即 的所有质因数都一定出现偶数次,故我们只需要对 进行质因数分解,然后将所有出现了奇数次方的质因数乘在一起即为答案(将奇数补成偶数)。时间复杂度:
Code
using namespace std; //========================================== typedef long long ll; map<ll, int> fac(ll n) { map<ll, int> ret; for(ll i=2;i*i<=n;i++) { while(n%i==0) { n/=i; ++ret[i]; } } if(n!=1) ++ret[n]; return ret; } signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== ll n; cin>>n; auto facts = fac(n); ll mul = 1; for(auto [x,y] : facts) if(y%2) mul *= x; cout<<mul<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
负载均衡
可以把分配任务想象成向计算机借了一些算力,时间到了后再还回去
于是我们开一个堆来维护要还回去的算力,对于每次操作先把时间到了的需要还回去的算力还回去,再判断此次能否借来算力,若能借来算力,把计算机的算力扣除了借走的算力后,在堆中打一个欠条。重复此流程即可,时间复杂度:
Code
using namespace std; //========================================== const int maxn = 2e5+5; typedef tuple<int,int,int> tp3; int v[maxn]; priority_queue<tp3, vector<tp3>, greater<tp3>> pq; signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int n,m; cin>>n>>m; for(int i=1;i<=n;i++) cin>>v[i]; while(m--) { int a,b,c,d; cin>>a>>b>>c>>d; while(!pq.empty()&&get<0>(pq.top())<=a) { auto [_,j,k] = pq.top(); pq.pop(); v[j]+=k; } if(v[b]>=d) { v[b]-=d; cout<<v[b]<<'\n'; pq.emplace(a+c, b, d); } else cout<<-1<<'\n'; } //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
国际象棋
发现此题即 [SCOI2005] 互不侵犯 的加强版。把王换成马,即会跟上两行有关系罢了
状压 DP,把每行棋子放法用 01 串来表示,放了马为 1,没放为 0:
- 状态设计: 代表当前放到第 行,放法为 ,上一行放法为 ,已经放了 个马的方案数
- 初始状态: (同一行的马不会互相攻击所以可以随便放)
- 转移方程:
- 所求结果:
注意数据范围 ,即 ,故我们把 当做行来处理可以极大地缩小空间时间复杂度,最终时间复杂度:
Code
using namespace std; //========================================== const int maxn = (1<<6)+5; const int mod = 1e9+7; int pc[maxn]; int dp[105][maxn][maxn][25]; signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== int n,m,k; cin>>n>>m>>k; for(int i=0;i<(1<<n);i++) { pc[i]=__builtin_popcount(i); if(pc[i]>k) continue; dp[1][i][0][pc[i]]=1; } for(int i=2;i<=m;i++) { for(int p=0;p<(1<<n);p++) { for(int q=0;q<(1<<n);q++) { if(p<<2&q || p>>2&q) continue; for(int a=0;a<(1<<n);a++) { if(p<<1&a || p>>1&a) continue; for(int j=pc[p];j<=k;j++) { dp[i][p][q][j] += dp[i-1][q][a][j-pc[p]]; dp[i][p][q][j] %= mod; } } } } } int sum = 0; for(int p=0;p<(1<<n);p++) for(int q=0;q<(1<<n);q++) sum = (sum + dp[m][p][q][k]) % mod; cout<<sum<<endl; //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }
完美序列
鸣谢:感谢 @Tifa 大佬提供的主要思路
读完题目,我们可以轻松获取如下三个结论(以下简称“ 至 的所有排列中长度正好为 阶最大完美长度的最长完美子序列”为“最长完美子序列”:
- 阶最大完美长度为
- 每个“最长完美子序列”一定以 为结尾
- 每个“最长完美子序列”中一定只存在前一个数是后一个数的 倍或 倍,且 倍只出现一次
第一个结论是显然的,因为下降最慢的完美序列为等比数列 ,故一个最大值为 的完美序列的最大长度为
第二个结论采取反证法:若存在一个“最长完美子序列” 不以 为结尾,那么一定存在一个完美子序列 比 长,那么 必然不是最长的,矛盾
第三个结论采取反证法:首先,若出现了 倍以上,即以长度 出现了 倍以上(例:),但我们至少可以用长度 来出现 倍(),也就说说若出现了 倍以上,那么此“最长完美子序列”必然不是最长的,矛盾;其次,若出现了两个 倍,即以长度 出现了 倍(例:),但我们可以用长度 来出现 倍(),也就是说若出现了 倍,那么此“最长完美子序列”必然不是最长的,矛盾
有了如上三个结论,我们就可以开始考虑如何解决这个问题了。设 阶最大完美长度为 ,我们分情况讨论:
“最长完美子序列”中不存在 倍,即“最长完美子序列”为:
此时“最长完美子序列”为等比数列 ,由等比数列求和公式 ,此情况下“最长完美子序列”的和为:
“最长完美子序列”中存在 倍,即“最长完美子序列”为:
注意:只有当 时才会出现此情况
设 为存在 倍情况下所有长度为 的“最长完美子序列”的和,则有:

递推预处理即可。以 为例,上式的各部分如下:

当然,也可以使用此递推式的通项公式 直接算出结果
于是对于一个给定的 ,我们只需要判断一下是否可能出现第二种情况,根据上文所述即可获取所有“最长完美子序列”的和
注意“最长完美子序列”是 至 的所有排列的子序列,也就是说每个“最长完美子序列”会出现多次,其出现次数为 ,在计算答案时需要乘进去
为什么是 呢? 至 的所有排列共有 个,而其中“最长完美子序列”的相对位置是不变的,所以除掉“最长完美子序列”的排列数
注意到出现了有理数取余,需要预处理阶乘及其逆元 。数据规模 不是很大,采用 或者 求逆元都可以。
若采用 求逆元则总时间复杂度为 ;若采用 求逆元则总时间复杂度为
Code
using namespace std; //========================================== const int maxn = 1e6+5; const int mod = 1e9+7; typedef long long ll; ll qpow(ll a,ll k) { ll res = 1; for(;k;k>>=1,a=a*a%mod) if(k&1) res=res*a%mod; return res; } ll fct[maxn]={0,1}, inv[maxn]={0,1}; inline void inv1() //? 快速幂 O(nlogn) 求逆元 { for(int i=2;i<=1e6;i++) inv[i]=qpow(fct[i], mod-2); } ll s[maxn], sv[maxn]; inline void inv2() //? 线性求任意 n 个数的逆元 { int n = 1e6; s[1]=1; for(int i=2;i<=n;i++) s[i]=s[i-1]*fct[i]%mod; sv[n]=qpow(s[n], mod-2); for(int i=n-1;i>=1;i--) sv[i]=sv[i+1]*fct[i+1]%mod; for(int i=2;i<=n;i++) inv[i]=sv[i]*s[i-1]%mod; } signed main(signed argc, char const *argv[]) { freopen("in.in", "r", stdin); freopen("out.out", "w", stdout); clock_t c1 = clock(); ios::sync_with_stdio(false); cin.tie(nullptr); //====================================== for(int i=2;i<=1e6;i++) fct[i]=fct[i-1]*i%mod; inv2(); // 使用线性求任意 n 个数的逆元 int t; cin>>t; while(t--) { int n; cin>>n; if(n==1) cout<<1<<endl; else { ll len = (ll)log2(n)+1; ll a = fct[n]*inv[len]%mod; ll c1 = a*((1<<len)-1)%mod; if(n<3*(1<<(len-2))) cout<<c1<<'\n'; else cout<<(c1+a*((1<<(len-1))*(3*len-4)-len+2))%mod<<'\n'; } } //====================================== cerr << "Time Used:" << clock() - c1 << "ms" << endl; return 0; }